program executercommande;

// |===========================================================================|
// | PROGRAM executercommande                                                  |
// | F.BASSO 2020                                                              |
// |___________________________________________________________________________|
// | Logiciel de demonstration permettant d'executer une commande et d'afficher|
// | le resultat                                                               |
// |___________________________________________________________________________|
// | Ce programme est libre, vous pouvez le redistribuer et ou le modifier     |
// | selon les termes de la Licence Publique Gnrale GNU publie par la       |
// | Free Software Foundation .                                                |
// | Ce programme est distribu car potentiellement utile,                     |
// | mais SANS AUCUNE GARANTIE, ni explicite ni implicite,                     |
// | y compris les garanties de commercialisation ou d'adaptation              |
// | dans un but spcifique.                                                   |
// | Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.    |
// |                                                                           |
// | anbasso@wanadoo.fr                                                        |
// |___________________________________________________________________________|
// | Versions                                                                  |
// |  _________                                                                |
// | /  1.0.0  \______________________________________________________________ |
// || 2020/03/31 F.BASSO                                                      ||
// || Cration du programme                                                   ||
// ||_________________________________________________________________________||
// |===========================================================================|

{$APPTYPE CONSOLE}

{$R *.res}

uses
  System.SysUtils,
  Posix.Base;

type
  TStreamHandle = pointer;

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Dclaration des API                                                       #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

function popen  ( const aStcommand: MarshaledAString; const aStrType: MarshaledAString ): TStreamHandle; cdecl; external libc name _PU + 'popen';
//  ___________________________________________________________________________
// | Function popen                                                            |
// | _________________________________________________________________________ |
// || Permet de crer un processus en crant un tube (pipe)                   ||
// ||_________________________________________________________________________||
// || Entres | const aStcommand: MarshaledAString                            ||
// ||         |   commande a executer                                         ||
// ||         | const aStrType: MarshaledAString                              ||
// ||         |    r  pour la lecture ou  w  pour l'criture              ||
// ||_________|_______________________________________________________________||
// || Sorties | result : TStreamHandle                                        ||
// ||         |   nul ou -1 si nok                                            ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

function pclose ( filehandle: TStreamHandle ): int32; cdecl; external libc name _PU + 'pclose';
//  ___________________________________________________________________________
// | Function pclose                                                           |
// | _________________________________________________________________________ |
// || Permet d'attendre la fermeture du processus                             ||
// ||_________________________________________________________________________||
// || Entres | filehandle: TStreamHandle                                     ||
// ||         |   Handle du processus ouvert                                  ||
// ||_________|_______________________________________________________________||
// || Sorties | result : integer                                              ||
// ||         |   resultat de l'execution 0 ok -1 nok                         ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

function fgets  ( buffer : pointer ; size : int32 ; Stream : TStreamHAndle ) : pointer; cdecl; external libc name _PU + 'fgets';
//  ___________________________________________________________________________
// | Function fgets                                                            |
// | _________________________________________________________________________ |
// || Permet de recuperrer un string depuis un flux                           ||
// ||_________________________________________________________________________||
// || Entres | buffer : pointer                                              ||
// ||         |   string lut                                                  ||
// ||         | size : int32                                                  ||
// ||         |   taille a lire                                               ||
// ||         | Stream : TStreamHAndle                                        ||
// ||         |   flux d'ou recuperrer le string                              ||
// ||_________|_______________________________________________________________||
// || Sorties | result : pointer                                              ||
// ||         |   nul si nok                                                  ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

// #===========================================================================#
// #===========================================================================#
// #                                                                           #
// # Dclaration des fonctions                                                 #
// #                                                                           #
// #===========================================================================#
// #===========================================================================#

function BufferToString( Buffer: pointer; MaxSize: uint32 ): string;

//  ___________________________________________________________________________
// | function BufferToString                                                   |
// | _________________________________________________________________________ |
// || Permet de convertir un buffer en chaine de caractres                   ||
// ||_________________________________________________________________________||
// || Entres | Buffer: pointer                                               ||
// ||         |   buffer  convertir                                          ||
// ||         | MaxSize: uint32                                               ||
// ||         |   taille a convertir                                          ||
// ||_________|_______________________________________________________________||
// || Sorties | result : string                                               ||
// ||         |   chaine convertie                                            ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  cursor: ^uint8;
  EndOfBuffer: nativeuint;
begin
  Result := '';
  if not assigned(Buffer) then
  begin
    exit;
  end;
  cursor := Buffer;
  EndOfBuffer := NativeUint ( cursor ) + MaxSize;
  while ( NativeUint ( cursor ) < EndOfBuffer ) and ( cursor^ <> 0 ) do
  begin
    Result := Result + chr ( cursor^ );
    cursor := pointer ( succ ( NativeUInt ( cursor ) ) );
  end;
end;

function strExecuteCommande ( aStrCommande : string ; aStrMode :string ) : string;
//  ___________________________________________________________________________
// | function strExecuteCommande                                               |
// | _________________________________________________________________________ |
// || Permet d'executer une commande est renvoie le resultat                  ||
// ||_________________________________________________________________________||
// || Entres | aStrCommande : MarshaledAString                               ||
// ||         |   ligne de commande  executer                                ||
// ||         | aStrMode :MarshaledAString                                    ||
// ||         |    r  pour la lecture ou  w  pour l'criture              ||
// ||_________|_______________________________________________________________||
// || Sorties | result  : string                                              ||
// ||         |   resultat de la commande                                     ||
// ||_________|_______________________________________________________________||
// |___________________________________________________________________________|

var
  Handle: TStreamHandle;
  Data: array[0..511] of uint8;
begin
  result := '';
  Handle := popen(PAnsiChar(AnsiString( aStrCommande )) , PAnsiChar(AnsiString( aStrMode)) );
  try
    while fgets(@data[0],Sizeof(Data),Handle)<>nil do
	begin
      result := result + BufferToString(@Data[0],sizeof(Data));
    end;
  finally
    pclose(Handle);
  end;
end;

begin
  try
    { TODO -oUser -cConsole Main : Insrer du code ici }
    write( 'Le nom de la machine est : ' + strExecuteCommande ('/bin/hostname','r' ));
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;
end.
